import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class Parser {

    List<Lieu> lieux = new ArrayList<>();

    List<Route> routes = new ArrayList<>();

    String pathLieux = "C:\\Users\\tb85\\Documents\\Polytech_Nantes\\Semestre_6\\MiniProjetJava\\progps\\villes.txt";

    String pathRoutes = "C:\\Users\\tb85\\Documents\\Polytech_Nantes\\Semestre_6\\MiniProjetJava\\progps\\routes.txt";

    Parser(){
        parserLieux();
        parserRoutes();

    }

    public void parserLieux(){

        try {
            File fichier = new File(pathLieux);
            Scanner scanner = new Scanner(fichier);
            while(scanner.hasNextLine()){
                String ligne = scanner.nextLine();

                String [] elements = ligne.split(", ");

                if (elements.length >= 4) {
                    String typeLieuString = elements[0];
                    String nomLieu = elements[1];
                    String nomVille = elements[2];
                    String posStr = elements[3] + ", " + elements[4];

                    if (!scanner.hasNext()) {
                        posStr = posStr.substring(1, posStr.length() - 2);
                    } else {
                        posStr = posStr.substring(1, posStr.length() - 1);

                    }
                    String[] coords = posStr.split(", ");
                    Position pos = new Position(Integer.parseInt(coords[0]),Integer.parseInt(coords[1]));


                    TypeLieu typeLieu = switch (typeLieuString) {
                        case "B" -> TypeLieu.B;
                        case "R" -> TypeLieu.R;
                        case "L" -> TypeLieu.L;
                        default -> null;
                    };
                    this.lieux.add(new Lieu(typeLieu, nomLieu, nomVille, pos));
                } else {
                    System.out.println("Ligne invalide: " + ligne);
                }


            }
            scanner.close();
            //lieux.forEach(lieu -> System.out.println(lieu.toString()));
        }
        catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        }
    }

    public void parserRoutes(){
        try {
            File fichier = new File(pathRoutes);
            Scanner scanner = new Scanner(fichier);
            while (scanner.hasNextLine()){
                String line = scanner.nextLine();
                String[] parts = line.split(",\\s*(?![^()]*\\))");
                List<Object> result = new ArrayList<>();
                for (String part : parts) {
                    part = part.trim();
                    if (part.startsWith("(")) {
                        String[] numbers = part.replaceAll("[^\\d,]", "").split(",");
                        result.addAll(Arrays.asList(numbers));
                    } else {
                        result.add(part);
                    }
                }
                String nomRoute;
                if (result.size() % 2 == 1) {
                    nomRoute = (String) result.get(result.size() - 1);
                    result = result.subList(0, result.size() - 1);
                }
                else {
                    nomRoute = "";
                }

                int tailleResult = result.size();
                int decalage = 0;
                ArrayList<Segment> listSegments = new ArrayList<>();

                // Position segments
                while (decalage + 3 <= tailleResult - 1){
                    int x1 = Integer.parseInt((String) result.get(decalage));
                    int y1 = Integer.parseInt((String) result.get(decalage + 1));
                    int x2 = Integer.parseInt((String) result.get(decalage + 2));
                    int y2 = Integer.parseInt((String) result.get(decalage + 3));

                    Position debut = new Position(x1,y1);
                    Position fin = new Position(x2,y2);
                    Segment segment = new Segment(debut,fin);
                    listSegments.add(segment);
                    decalage += 2;
                }
                // Position debut et fin route
                int x1 = Integer.parseInt((String)  result.get(0));
                int y1 = Integer.parseInt((String)  result.get(1));

                int x2 = Integer.parseInt((String)  result.get(tailleResult - 2));
                int y2 = Integer.parseInt((String)  result.get(tailleResult - 1));

                Position debut = new Position(x1,y1);
                Position fin = new Position(x2,y2);

                Lieu lieuDepart = findLieu(debut);
                Lieu lieuArrive = findLieu(fin);

                Route route = new Route(lieuDepart,lieuArrive,listSegments,nomRoute);
                routes.add(route);


            }
        } catch (FileNotFoundException ex) {
            throw new RuntimeException(ex);
        }

    }

    public Lieu findLieu(Position pos){

        for (Lieu lieu: this.lieux){
            if (lieu.pos.x == pos.x && lieu.pos.y == pos.y) {
                return lieu;
            }
        }
        return null;
    }

    public static void main(String [] args){
        Parser parser = new Parser();
        System.out.println("-----LIEUX-----");
        parser.lieux.forEach(System.out::println);
        System.out.println("-----ROUTES-----");
        parser.routes.forEach(System.out::println);
    }

}
